diff -Nur linux-2.4.30/drivers/usb/gadget/amd5536uoc.c linux-2.4.30-linux-mips.org/drivers/usb/gadget/amd5536uoc.c
--- linux-2.4.30/drivers/usb/gadget/amd5536uoc.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/gadget/amd5536uoc.c	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,1394 @@
+/*
+ * AMD 5536 USB OTG controller driver
+ */
+
+/*
+ * Copyright (C) 2005 AMD (http://www.amd.com)
+ * Author: Karsten Boge 
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+/*****************************************************************************
+ *  Includes
+ *****************************************************************************/
+
+#include <linux/config.h>
+#include <linux/module.h>
+#include <linux/pci.h>
+#include <linux/kernel.h>
+#include <linux/version.h>
+#include <linux/delay.h>
+#include <linux/ioport.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/smp_lock.h>
+#include <linux/errno.h>
+#include <linux/init.h>
+#include <linux/timer.h>
+#include <linux/list.h>
+#include <linux/interrupt.h>
+
+#include <asm/byteorder.h>
+#include <asm/io.h>
+#include <asm/irq.h>
+#include <asm/system.h>
+#include <asm/unaligned.h>
+
+#ifdef CONFIG_TEST_INTERFACE
+#ifndef CONFIG_USB_OTG
+#define CONFIG_USB_OTG
+#endif
+#endif
+/* #define DEBUG */
+/* #define VERBOSE */
+
+#include <linux/usb_otg.h>
+#include <linux/usb.h>
+
+#define	DRIVER_DESC		"AMD 5536 USB OTG Controller"
+#define DRIVER_VERSION          "01.00.0000 - kernel 2.4.29, $Revision: #115 $"
+#define DRIVER_NAME_FOR_PRINT   OTG_DRIVER_NAME
+#include "amd5536uoc.h"
+
+
+/*****************************************************************************
+ *  Function Declarations
+ *****************************************************************************/
+
+#ifdef CONFIG_TEST_INTERFACE
+static int otg_test_bind(struct otg **);
+static int otg_test_unbind(struct otg **);
+#endif
+#ifdef CONFIG_USB_OTG
+static int otg_bind_host(struct usb_bus *);
+static int otg_unbind_host(struct usb_bus *);
+static int otg_app_request(u32);
+#endif
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_GADGET)
+static int otg_bind_gadget(void);
+static int otg_unbind_gadget(void);
+static u32 otg_app_query(int);
+#endif
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+static inline void otg_req_state_chg (struct otg *, u32);
+#endif
+
+
+/*****************************************************************************
+ *  Data
+ *****************************************************************************/
+
+static const char driver_name [] = OTG_DRIVER_NAME;
+static const char driver_desc [] = DRIVER_DESC;
+
+static struct otg *the_controller;
+
+static u32 init_state = 0;
+
+#ifdef CONFIG_TEST_INTERFACE
+static struct usb_test_otg_extension otg_test_driver = {
+	.bind    = otg_test_bind,
+	.unbind  = otg_test_unbind,
+	.request = otg_app_request,
+	.query   = otg_app_query
+};
+#endif
+
+#ifdef CONFIG_USB_OTGMUX_GADGET
+static struct usb_gadget_otg_extension otg_gadget_driver = {
+	.bind    = otg_bind_gadget,
+	.unbind  = otg_unbind_gadget,
+	.request = NULL,
+	.query   = otg_app_query,
+	.notify  = NULL
+};
+#endif
+
+#ifdef CONFIG_USB_OTG
+static struct usbcore_otg_extension otg_host_driver = {
+	.bind    = otg_bind_host,
+	.unbind  = otg_unbind_host,
+	.request = otg_app_request,
+	.query   = otg_app_query
+};
+
+static struct usb_gadget_otg_extension otg_gadget_driver = {
+	.bind    = otg_bind_gadget,
+	.unbind  = otg_unbind_gadget,
+	.request = otg_app_request,
+	.query   = otg_app_query,
+	.notify  = NULL
+};
+#endif /* CONFIG_USB_OTG */
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+static struct otg_ctl __otg_ctl = {
+	.act_state  = OTG_NOT_ASSIGNED,
+	.prv_state  = OTG_NOT_ASSIGNED,
+	.params     = 0,
+};
+static struct otg_ctl *otg_ctl = &__otg_ctl;
+
+static u32 state_mask;
+static u32 high_count = 0;
+#endif
+
+#ifdef CONFIG_USB_NON_PCI_OTGDEVICE  /* Au1200 */
+static struct pci_dev pdev_dummy;
+
+static au1x00_gpio_bit_ctl init_usb_vbus_switch = {
+	.direction = 1,  /* out */
+	.data      = 1   /* set */
+};
+#endif
+
+
+/*****************************************************************************
+ *  Function Definitions
+ *****************************************************************************/
+
+#if defined(CONFIG_USB_OTGMUX_IDPIN) || defined(CONFIG_USB_HSA0_GADGET)
+/**
+ * \brief
+ * OTG state change
+ *
+ * subset of OTG states to support the gadget only or
+ * ID pin configuration
+ *
+ * \param  dev          OTG controller info
+ * \param  event_code   event that requested a state change
+ * \param  pEvt_mask
+ *
+ * \return              events that were not handled here
+ */
+u32 otg_change_state (struct otg *dev, u32 _event, u32 *pEvt_mask)
+{
+	u32  event_code = _event;
+	u32  uoc_status = get_status (dev);
+
+	if (GOT_EVENT (OTG_GADGET_READY, event_code) &&
+	    ((otg_ctl->act_state & OTG_STATE_MASK) != OTG_NOT_ASSIGNED)) {
+
+		/* Switch from "NO_B_DEVICE" states to normal operation or   */
+		/*       deactivate operations in case gadget was unloaded   */
+
+		CHANGE_STATE (dev, OTG_NOT_ASSIGNED, pEvt_mask);
+	}
+	if ((OTG_INT_TMX & event_code) && high_count) {
+
+		/* a long timer is running : decrement the high part         */
+
+		restart_timer (dev);
+		high_count--;
+		RES_EVENT (OTG_INT_TMX, event_code);
+	}
+
+	do switch (otg_ctl->act_state & OTG_STATE_MASK) {
+
+	/* NOT_ASSIGNED (yet): init state, 1st time after loading            */
+	/* ======================================================            */
+
+	case OTG_NOT_ASSIGNED :
+
+		CHECK_STATE (dev, OTG_NOT_ASSIGNED);
+
+		if (IS_FLAG_RES (OTG_FLAGS_ACTIV)) {
+
+			/* seems to be the first time: let it run !          */
+
+			SET_FLAG (OTG_FLAGS_ACTIV);
+		}
+
+		/*      muxer is still neutral                               */
+
+		RES_EVENT ((OTG_INT_IDC | OTG_INT_TMX), event_code);
+
+		if (IS_FLAG_RES (OTG_GADGET_READY)) {
+
+			/* NOT_READY (substate): gadget drivers not ready    */
+			/* ==============================================    */
+			/*                                                   */
+			/*     check ID pin and enable host as needed        */
+
+			if (IS_BIT_RES (OTG_STS_ID, uoc_status)) {
+
+				/* ID pin connected: A-device (host)         */
+
+				if (OTG_NO_B_DEVICE_A != otg_ctl->act_state) {
+					CHANGE_STATE (dev, OTG_NO_B_DEVICE_A,
+					              pEvt_mask);
+				}
+			}
+			else if (IS_BIT_SET (OTG_STS_ID, uoc_status)) {
+
+				/* ID pin not connected: disable (neutral)   */
+
+				if (OTG_NO_B_DEVICE_B != otg_ctl->act_state) {
+					CHANGE_STATE (dev, OTG_NO_B_DEVICE_B,
+					              pEvt_mask);
+				}
+			}
+		}
+		else if ((OTG_NO_B_DEVICE_A == otg_ctl->act_state) ||
+		         (OTG_NO_B_DEVICE_B == otg_ctl->act_state)) {
+
+			/* Exit "not ready" state                            */
+			/* ----------------------                            */
+
+			RES_EVENT (OTG_GADGET_READY, event_code);
+			CHANGE_STATE (dev, OTG_NOT_ASSIGNED, pEvt_mask);
+		}
+
+		/* ==================================================        */
+
+#ifdef CONFIG_USB_OTGMUX_IDPIN
+
+		else if (IS_BIT_RES (OTG_STS_ID, uoc_status)) {
+
+			/* ID pin connected: A-device (host)                 */
+
+			CHANGE_STATE (dev, OTG_A_HOST, pEvt_mask);
+		}
+#endif
+		else {
+
+			/* ID pin is not connected: B-device (peripheral)    */
+
+			CHANGE_STATE (dev, OTG_B_IDLE, pEvt_mask);
+		}
+		break;
+
+#ifdef CONFIG_USB_OTGMUX_IDPIN
+
+	/* A: ID pin is connected, A-device drives VBus                      */
+	/* ============================================                      */
+
+	case OTG_A_HOST :
+
+		CHECK_STATE (dev, OTG_A_HOST);
+
+		if (IS_BIT_SET (OTG_STS_ID, uoc_status)) {
+
+			/* ID change => B_IDLE                               */
+
+			RES_EVENT ((OTG_INT_IDC | OTG_INT_PCC), event_code);
+			CHANGE_STATE (dev, OTG_B_IDLE, pEvt_mask);
+		}
+		break;
+
+	/* B: ID pin is not connected                                        */
+	/* ==========================                                        */
+#endif
+
+	case OTG_B_IDLE :
+
+		/* B_IDLE: init state for B-devices                          */
+		/*         monitor VBus, no connection, no activity          */
+
+		CHECK_STATE (dev, OTG_B_IDLE);
+
+#ifdef CONFIG_USB_OTGMUX_IDPIN
+
+		if (IS_BIT_RES (OTG_STS_ID, uoc_status)) {
+
+			/* ID pin changed => A_HOST                          */
+
+			RES_EVENT (OTG_INT_IDC, event_code);
+			CHANGE_STATE (dev, OTG_A_HOST, pEvt_mask);
+		}
+		else if (IS_BIT_SET (OTG_STS_SESSVLD, uoc_status))
+#else
+		if (IS_BIT_SET (OTG_STS_SESSVLD, uoc_status))
+#endif
+		{
+			/* Session valid => B_PERIPHERAL                     */
+
+			RES_EVENT (OTG_INT_SVC, event_code);
+			CHANGE_STATE (dev, OTG_B_PERIPHERAL, pEvt_mask);
+		}
+		break;
+
+	case OTG_B_PERIPHERAL :
+
+		/* B_PERIPHERAL: connected to A-host, responding             */
+		/*               VBus driven by A, remote activity           */
+
+		CHECK_STATE (dev, OTG_B_PERIPHERAL);
+
+#ifdef CONFIG_USB_OTGMUX_IDPIN
+
+		if (IS_BIT_RES (OTG_STS_ID, uoc_status) ||
+		    IS_BIT_RES (OTG_STS_SESSVLD, uoc_status))
+#else
+		if (IS_BIT_RES (OTG_STS_SESSVLD, uoc_status))
+#endif
+		{
+			/* ID pin changed | ~Session valid => B_IDLE         */
+
+			RES_EVENT ((OTG_INT_IDC | OTG_INT_SVC), event_code);
+			CHANGE_STATE (dev, OTG_B_IDLE, pEvt_mask);
+		}
+		break;
+
+	/* unlikely */ default :
+
+		/* something went wrong */
+
+		BUG ();
+		break;
+	}
+	while ((otg_ctl->act_state ^ otg_ctl->prv_state) & OTG_STATE_MASK);
+
+	DBG ("OTG-state change done\n");
+
+	return event_code;
+}
+#endif /* CONFIG_USB_OTGMUX_IDPIN || CONFIG_USB_HSA0_GADGET */
+
+#ifdef CONFIG_TEST_INTERFACE
+static int otg_test_bind (struct otg **dev)
+{
+	*dev = the_controller;
+	if (!*dev)
+		return -EINVAL;
+#ifdef CONFIG_TEST_MODE_ONLY
+	INFO ("bind OTG driver to the test driver, enable device\n");
+	SET_FLAG (OTG_HOST_READY | OTG_GADGET_READY);
+	if (IS_FLAG_SET (OTG_FLAGS_ACTIV)) {
+		otg_req_state_chg (the_controller,
+		                   OTG_HOST_READY | OTG_GADGET_READY);
+	}
+	the_controller->gadgetflag = 1;
+#else
+	INFO ("bind OTG driver to the test interface\n");
+#endif
+	return 0;
+}
+
+static int otg_test_unbind (struct otg **dev)
+{
+	*dev = NULL;
+#ifdef CONFIG_TEST_MODE_ONLY
+	INFO ("unbind OTG driver from the test driver, disable device\n");
+	the_controller->gadgetflag = 0;
+	RES_FLAG (OTG_HOST_READY | OTG_GADGET_READY);
+	if (IS_FLAG_SET (OTG_FLAGS_ACTIV)) {
+		otg_req_state_chg (the_controller,
+		                   OTG_HOST_READY | OTG_GADGET_READY);
+	}
+	return (otg_unbind_gadget ());
+#else
+	INFO ("unbind OTG driver from the test interface\n");
+	return 0;
+#endif
+}
+#endif /* CONFIG_TEST_INTERFACE */
+
+#ifdef CONFIG_USB_OTG
+
+/**
+ * \brief
+ * Bind the OTG controller to usbcore
+ *
+ * \param  bus   usb bus the host is assigned to
+ *
+ * \return error code
+ */
+static int otg_bind_host (struct usb_bus *bus)
+{
+	/* This bus supports OTG */
+
+	bus->otghost->otgpriv = (void *) the_controller;
+	the_controller->hostcount++;
+	DBG ("bind OTG driver to USB core: bus %d, port %d (OTG host %d)\n",
+	     bus->busnum, bus->otghost->otgport + 1,
+	     the_controller->hostcount);
+	if (IS_FLAG_RES (OTG_HOST_READY)) {
+		RES_FLAG (OTG_A_BUS_DROP);
+		SET_FLAG (OTG_HOST_READY | OTG_A_BUS_REQ);
+		if (IS_FLAG_SET (OTG_FLAGS_ACTIV)) {
+			otg_req_state_chg (the_controller, OTG_HOST_READY);
+		}
+	}
+	return 0;
+}
+
+/**
+ * \brief
+ * Unbind the OTG controller from usbcore
+ *
+ * \param  bus   usb bus the host is assigned to
+ *
+ * \return error code
+ */
+static int otg_unbind_host (struct usb_bus *bus)
+{
+	DBG ("unbind OTG driver from USB core (actual OTG hosts: %d)\n",
+	     the_controller->hostcount);
+	the_controller->hostcount--;
+	if (!the_controller->hostcount) {
+		RES_FLAG (OTG_HOST_READY | OTG_A_BUS_REQ);
+		SET_FLAG (OTG_A_BUS_DROP);
+		if (IS_FLAG_SET (OTG_FLAGS_ACTIV)) {
+			otg_req_state_chg (the_controller, OTG_HOST_READY);
+		}
+	}
+	bus->otghost->otgpriv = NULL;
+	return 0;
+}
+#endif /* CONFIG_USB_OTG */
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_GADGET)
+
+/**
+ * \brief
+ * Bind the OTG controller to the gadget
+ *
+ * \param  void
+ *
+ * \return error code
+ */
+static int otg_bind_gadget (void)
+{
+	if (the_controller->gadgetflag) {
+		ERR ("USB gadget: OTG driver already registered\n");
+		return -EBUSY;
+	}
+	DBG ("bind OTG driver to USB gadget\n");
+	the_controller->gadgetflag = 1;
+	SET_FLAG (OTG_GADGET_READY | OTG_B_BUS_REQ);
+	if (IS_FLAG_SET (OTG_FLAGS_ACTIV)) {
+		otg_req_state_chg (the_controller, OTG_GADGET_READY);
+	}
+	return 0;
+}
+
+/**
+ * \brief
+ * Unbind the OTG controller from the gadget
+ *
+ * \param  void
+ *
+ * \return error code
+ */
+static int otg_unbind_gadget (void)
+{
+	DBG ("unbind OTG driver from USB gadget\n");
+	RES_FLAG (OTG_GADGET_READY | OTG_B_BUS_REQ);
+	if (IS_FLAG_SET (OTG_FLAGS_ACTIV)) {
+		otg_req_state_chg (the_controller, OTG_GADGET_READY);
+	}
+	the_controller->gadgetflag = 0;
+	return 0;
+}
+#endif /* CONFIG_USB_OTG || CONFIG_USB_OTGMUX_GADGET */
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+/**
+ * \brief
+ * OTG state change request
+ *
+ * \param  dev    OTG device info
+ * \param  params
+ *
+ * \return void
+ */
+static inline void otg_req_state_chg (struct otg *dev, u32 params)
+{
+	u32 temp;
+
+	/* disable global OTG interrupt:                                     */
+	temp = ~((u32) OTG_INT_GLOBAL) & readl (&dev->regs->inten);
+	writel (temp, &dev->regs->inten);
+	temp &= readl (&dev->regs->intr);
+	if (temp) {
+		writel (temp, &dev->regs->intr);
+	}
+	/* update OTG state:                                                 */
+	otg_change_state (dev, (params | temp), &temp);
+
+	/* enable global OTG interrupt:                                      */
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3950: gadget needs disconnect notification              ***/
+#ifdef UDC_HSA0_WORKAROUNDS
+	state_mask = ~temp & OTG_INT_ADDS;
+	writel ((OTG_INT_ADDS | temp | OTG_INT_GLOBAL), &dev->regs->inten);
+#else
+	writel ((temp | OTG_INT_GLOBAL), &dev->regs->inten);
+#endif
+}
+#endif /* CONFIG_USB_OTGMUX || CONFIG_USB_OTGMUX_IDPIN || _HSA0_GADGET */
+
+#ifdef CONFIG_USB_OTG
+
+/**
+ * \brief
+ * OTG application request
+ *
+ * \param  params
+ *
+ * \return OTG_APP_REQ_ACK
+ */
+static int otg_app_request (u32 params)
+{
+	u32  flags = params;
+
+	if (OTG_AB_HNP_REQ & flags) {
+
+		/* HNP requested by application                              */
+
+		if (((the_controller->otg_ctl->act_state &
+		      OTG_STATE_MASK) != OTG_A_HOST) &&
+		    ((the_controller->otg_ctl->act_state &
+		      OTG_STATE_MASK) != OTG_B_HOST)) {
+
+			/* this is for host states only, otherwise ignore    */
+
+			flags &= ~((u32) OTG_AB_HNP_REQ);
+		}
+		else if (IS_FLAG_RES (OTG_A_bHNP_EN)) {
+
+			/* HNP still disabled: force enable                  */
+
+			flags |= OTG_A_bHNP_EN;
+		}
+	}
+	if (OTG_A_bHNP_EN & flags) {
+
+		/* HNP enable requested                                      */
+
+		if (IS_FLAG_RES (OTG_A_bHNP_EN) &&
+		    ((the_controller->otg_ctl->act_state &
+		      OTG_STATE_MASK) == OTG_A_HOST)) {
+
+			/* HNP still disabled: do it                         */
+
+			if (otg_enable_hnp (the_controller) < 0) {
+				ERR ("Couldn't enable HNP\n");
+			}
+		}
+	}               /* This is now done (OTG_A_bHNP_EN)                  */
+
+	if (OTG_A_CLR_ERR & flags) {
+
+		/* request to clear error flags                              */
+
+		flags |= OTG_A_VBUS_FAILED;
+	}
+
+	/* create mask of flags to clear                                     */
+
+	flags &= (OTG_B_SRP_ERROR | OTG_A_VBUS_FAILED);
+
+	if (flags) {
+
+		/* reset error flags if requested                            */
+
+		RES_FLAG ((flags));
+	}
+
+	/* prepare for pending requests (no more actions on OTG_A_bHNP_EN)   */
+
+	flags = params & (SW_REQUEST_MASK & ~((u32) OTG_A_bHNP_EN));
+	SET_FLAG ((flags));
+
+	if (OTG_A_BUS_DROP & flags) {
+
+		/* request to drop A-VBus: reset "rise" request if pending   */
+
+		flags &= ~OTG_A_BUS_REQ;
+		RES_FLAG (OTG_A_BUS_REQ);
+	}
+	if (OTG_A_BUS_REQ & flags) {
+
+		/* request to rise A-VBus: reset "drop" request if pending   */
+
+		RES_FLAG (OTG_A_BUS_DROP);
+	}
+	if (OTG_B_BUS_DIS & flags) {
+
+		/* request to disable B-dev: reset "ena" request if pending  */
+
+		flags &= ~OTG_B_BUS_REQ;
+		RES_FLAG (OTG_B_BUS_REQ);
+	}
+	if (OTG_B_BUS_REQ & flags) {
+
+		/* request to enable B-dev: reset "disa" request if pending  */
+
+		RES_FLAG (OTG_B_BUS_DIS);
+	}
+	if (flags) {
+
+		/* request still pending may force a state change            */
+
+		otg_req_state_chg (the_controller, flags);
+	}
+	return OTG_APP_REQ_ACK;
+}
+#endif /* CONFIG_USB_OTG */
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+/**
+ * \brief
+ * OTG application query
+ *
+ * \param  index   select status info data
+ *
+ * \return status
+ */
+static u32 otg_app_query (int index)
+{
+	u32  temp = 0;
+
+	if (index == 0) {
+		temp = otg_ctl->params | readl (&the_controller->regs->sts);
+
+/*** HS-A0 WA: BUG-3943: gadget phy suspend issue                          ***/
+#ifdef UDC_HSA0_WORKAROUNDS
+		if (((readl (&the_controller->regs->ctl) & OTG_CTL_MUX_MASK) ==
+		     OTG_CTL_ENABLE_UDC) &&
+		    ((temp & OTG_STS_PSUS) || (~temp & OTG_STS_VBUSVLD))) {
+			temp |= OTG_FLAGS_UDC_SUSP;
+		}
+#endif
+	}
+	else if (index == 1) {
+		temp = otg_ctl->act_state;
+	}
+	return (temp);
+}
+
+/**
+ * \brief
+ * OTG state activation
+ *
+ * \param  dev   OTG controller info
+ *
+ * \return void
+ */
+inline void otg_activate_state (struct otg *dev)
+{
+	u32 temp = 0;
+
+	/* Enable timer interrupt, start timer, set state                    */
+
+	SET_OTG_TIMER (dev, IDSNS_WAIT);
+	CHANGE_STATE (dev, OTG_NOT_ASSIGNED, &temp);
+	CHECK_STATE (dev, OTG_NOT_ASSIGNED);
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+/*** HS-A0 WA: BUG-3950: gadget needs disconnect notification              ***/
+
+	state_mask = ~temp & OTG_INT_ADDS;
+	writel ((OTG_INT_ADDS | temp | OTG_INT_GLOBAL), &dev->regs->inten);
+
+	DBG ("OTG-HW initialized, now checking ID ...\n");
+}
+
+/**
+ * \brief
+ * OTG ISR calling the main state machine
+ *
+ * \param  irq    IRQ number
+ * \param  _dev  
+ * \param  r     
+ *
+ * \return IRQ_HANDLED (system code)
+ */
+static irqreturn_t otg_isr (int irq, void *dev, struct pt_regs *r)
+{
+	u32         interrupts, int_mask;
+
+	int_mask = readl (&((struct otg *) dev)->regs->inten);
+	if ((OTG_INT_GLOBAL & int_mask) &&
+	    (int_mask &= ~((u32) OTG_INT_GLOBAL)) &&
+	    (interrupts = int_mask &
+		          readl (&((struct otg *) dev)->regs->intr))) {
+
+		writel (int_mask, &((struct otg *) dev)->regs->inten);
+		writel (interrupts, &((struct otg *) dev)->regs->intr);
+
+		/* filter out additional WA interrupts, they're done         */
+		/*       don't want to see them in the state machine         */
+
+		if (interrupts & ~state_mask) {
+
+			/* events pending for the state machine              */
+
+			otg_change_state ((struct otg *) dev,
+			                  (interrupts & ~state_mask),
+			                  &int_mask);
+		}
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+/*** HS-A0 WA: BUG-3950: gadget needs disconnect notification              ***/
+#ifdef UDC_HSA0_WORKAROUNDS
+#ifndef CONFIG_TEST_MODE_ONLY
+
+		if (GOT_EVENT (OTG_INT_SVC, interrupts) &&
+		    IS_FLAG_SET (OTG_GADGET_READY) &&
+		    otg_gadget_driver.notify) {
+
+			if (IS_BIT_RES (OTG_STS_SESSVLD, readl
+			        (&((struct otg *) dev)->regs->sts))) {
+
+				if ((otg_ctl->act_state & OTG_STATE_MASK) ==
+				    OTG_B_IDLE) {
+					VDBG ("calling gadget: disconnect\n");
+					otg_gadget_driver.notify
+					    (OTG_GADGET_EVT_SVDROP);
+				}
+			}
+			else {
+
+				if ((otg_ctl->act_state & OTG_STATE_MASK) ==
+				    OTG_B_PERIPHERAL) {
+					VDBG ("calling gadget: connect\n");
+					otg_gadget_driver.notify
+					    (OTG_GADGET_EVT_SVALID);
+				}
+			}
+		}
+#endif
+#endif /* UDC_HSA0_WORKAROUNDS */
+
+		/* enable interrupts and keep information about WA ints:     */
+
+		state_mask = OTG_INT_ADDS & ~int_mask;
+		writel ((OTG_INT_ADDS | int_mask | OTG_INT_GLOBAL),
+		        &((struct otg *) dev)->regs->inten);
+
+	}
+	return IRQ_HANDLED;
+}
+#endif /* CONFIG_USB_OTG || CONFIG_USB_OTGMUX_IDPIN || _HSA0_GADGET */
+
+/**
+ * \brief
+ * OTG state init
+ *
+ * \param  dev   OTG controller info
+ *
+ * \return void
+ */
+inline void otg_init_state (struct otg *dev)
+{
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+	int i;
+#endif
+
+	VDBG ("OTG init ...\n");
+
+#ifdef VERBOSE
+	/* print regs */
+	print_regs (dev);
+#endif
+	/* Make sure we'll remember the initial state                        */
+	init_state = readl (&dev->regs->ctl);
+	VDBG ("  OTG init state was %08x\n", init_state);
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+	/* turn on the OTG controller                                        */
+
+	writel ((init_state | OTG_CTL_PADEN), &dev->regs->ctl);
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+#ifndef UDC_HSA0_WORKAROUNDS
+
+	/* Enable OTG hardware (incl. auto pull-up enable)                   */
+
+	writel ((readl (&dev->regs->cap) | OTG_CAP_APU), &dev->regs->cap);
+#endif
+
+	/* initialize flags                                                  */
+	otg_ctl->params = 0;
+#endif
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+/*** HS-A0 WA: BUG-3950: gadget disconnect notification                    ***/
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+	/* make sure all interrupts are disabled                             */
+
+	writel (OTG_INT_DISALL, &dev->regs->inten);
+	writel (OTG_INT_ENALL, &dev->regs->intr);
+
+	/* Set multiplexer to neutral, get power control, drop VBus          */
+
+	if (((init_state & OTG_CTL_MUX_MASK) == OTG_CTL_ENABLE_UHC) &&
+	    ((((init_state & OTG_CTL_PPO) && (init_state & OTG_CTL_PPWR))) ||
+	     ((~init_state & OTG_CTL_PPO) &&
+	      (readl (&dev->regs->sts) & OTG_STS_SESSVLD)))) {
+
+		/* VBus still powered try to discharge VBus and set timer    */
+
+		DBG ("Setting init state, trying to discharge VBus ...\n");
+
+		for (i = 0; i < 4; i++) {
+			writel (TIMER_PERIOD, &dev->regs->tmr);
+			writel ((OTG_CTL_PADEN | OTG_CTL_IDSNSEN |
+			         OTG_CTL_PPO | OTG_CTL_DISCHRG |
+			         OTG_CTL_TMR_UNCOND), &dev->regs->ctl);
+			do { }
+			while (!(readl (&dev->regs->sts) & OTG_STS_TMH));
+		}
+		writel ((OTG_CTL_PADEN | OTG_CTL_IDSNSEN | OTG_CTL_PPO),
+		        &dev->regs->ctl);
+		writel (OTG_INT_ENALL, &dev->regs->intr);
+#ifdef DEBUG
+		if (readl (&dev->regs->sts) & OTG_STS_SESSVLD) {
+
+			DBG ("  VBus still high, external host connected");
+		}
+		else {
+
+			DBG ("  VBus discharged\n");
+		}
+#endif
+	}
+	else {
+		DBG ("Setting init state\n");
+
+		writel ((OTG_CTL_PADEN | OTG_CTL_IDSNSEN | OTG_CTL_PPO),
+		        &dev->regs->ctl);
+	}
+#else  /* !_OTG && !_IDPIN && !_HSA0 */
+#ifdef CONFIG_USB_OTGMUX_GADGET
+
+	/* Set multiplexer to gadget                                         */
+	writel ((readl (&dev->regs->cap) & ~((u32) OTG_CAP_APU)),
+	        &dev->regs->cap);
+	writel ((OTG_CTL_ENABLE_UDC | OTG_CTL_PADEN),
+	        &dev->regs->ctl);
+	INFO ("OTG functionality is disabled, port is assigned to device\n");
+#endif
+#endif /* CONFIG_USB_OTG || CONFIG_USB_OTGMUX_IDPIN || _HSA0_GADGET */
+
+#ifdef CONFIG_USB_OTGMUX_HOST
+
+	/* Set multiplexer to host                                           */
+	writel ((readl (&dev->regs->cap) & ~((u32) OTG_CAP_APU)),
+	        &dev->regs->cap);
+
+#ifndef CONFIG_USB_NON_PCI_OTGDEVICE
+
+	writel ((OTG_CTL_ENABLE_UHC | OTG_CTL_PADEN),
+	        &dev->regs->ctl);
+
+#else  /* Au1200 */
+	writel ((OTG_CTL_ENABLE_UHC | OTG_CTL_PPO | OTG_CTL_PPWR |
+	         OTG_CTL_PADEN), &dev->regs->ctl);
+
+	/* Turn on VBus                                                      */
+	au1000gpio_bit_clear (USB_VBUS_GPIO);
+#endif
+
+	INFO ("OTG functionality is disabled, port is assigned to host\n");
+#endif
+	VDBG ("OTG init done\n");
+}
+
+/**
+ * \brief
+ * OTG state exit
+ *
+ * \param  dev   OTG controller info
+ *
+ * \return       muliplexer state
+ */
+inline int otg_exit_state (struct otg *dev)
+{
+	int muxer;
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+	/* Disable all interrupts                                            */
+	writel (OTG_INT_DISALL, &dev->regs->inten);
+	writel (OTG_INT_ENALL, &dev->regs->intr);
+
+	/* reset state, terminate all connections                            */
+	CHANGE_STATE (dev, OTG_NOT_ASSIGNED, &state_mask);
+	CHECK_STATE (dev, OTG_NOT_ASSIGNED);
+	otg_ctl->params = 0;
+#endif
+
+	muxer = init_state & (OTG_CTL_ENABLE_UHC | OTG_CTL_ENABLE_UDC);
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+#ifdef UDC_HSA0_WORKAROUNDS
+
+	/* Don't assign the port to the device controller                    */
+
+	if (!(muxer ^ OTG_CTL_ENABLE_UDC)) {
+
+		init_state &= ~((u32) (OTG_CTL_MUX_MASK | OTG_CTL_PUEN));
+		muxer = OTG_CTL_DISABLE_ALL;
+	}
+	VDBG ("OTG writing back corrected init state: %08x\n", init_state);
+#else
+	/* Reset APU                                                         */
+
+	writel ((readl (&dev->regs->cap) & ~((u32) OTG_CAP_APU)),
+	        &dev->regs->cap);
+
+	VDBG ("OTG writing back init state: %08x\n", init_state);
+#endif
+	/* Now, that's the moment to remember                                */
+	/* Set dev muxer and pull up bits, turn off the OTG controller       */
+
+#ifdef CONFIG_USB_NON_PCI_OTGDEVICE  /* Au1200 */
+
+	/* Turn off VBus                                                     */
+	au1000gpio_bit_set (USB_VBUS_GPIO);
+#endif
+	writel (init_state, &dev->regs->ctl);
+
+	if (!(muxer ^ OTG_CTL_ENABLE_UHC)) {
+		INFO ("disabling OTG-HW, port is assigned to host\n");
+	}
+	else if (!(muxer ^ OTG_CTL_ENABLE_UDC)) {
+		INFO ("disabling OTG-HW, port is assigned to device\n");
+	}
+	else {
+		INFO ("disabling OTG-HW, port is not assigned\n");
+	}
+
+	VDBG ("OTG exit: OTG-HW disabled\n");
+
+	return muxer;
+}
+
+/**
+ * \brief
+ * OTG remove: clean up resources, remove driver
+ *
+ * \param  pdev  PCI device info
+ *
+ * \return void
+ */
+static void otg_remove (struct pci_dev *pdev)
+{
+	struct otg *dev = pci_get_drvdata (pdev);
+
+#ifndef CONFIG_TEST_MODE_ONLY
+#ifdef CONFIG_USB_OTG
+
+	/* unregistering from the usb core */
+	usb_bus_deregister_otg (&otg_host_driver);
+#endif
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_GADGET)
+
+	/* unregistering from the usb gadget */
+	usb_gadget_unregister_otg (&otg_gadget_driver);
+#endif
+#endif
+
+#ifdef CONFIG_TEST_INTERFACE
+
+	/* unregistering from the test driver */
+	usb_otg_test_unregister_driver (&otg_test_driver);
+#endif
+
+	/* clean up the OTG controller */
+	if (!(otg_exit_state (dev))) {
+		INFO ("OTG HW disabled, port is not assigned\n");
+	}
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+/*** HS-A0 WA: BUG-3950: gadget disconnect notification                    ***/
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+	/* then clean up the resources we allocated during probe() */
+	if (dev->got_irq)
+		free_irq (pdev->irq, dev);
+#endif
+
+	if (dev->regs)
+		iounmap (dev->regs);
+
+	if (dev->region)
+		release_mem_region (pci_resource_start (pdev, 0),
+                                    pci_resource_len (pdev, 0));
+
+#ifndef CONFIG_USB_NON_PCI_OTGDEVICE
+
+	if (dev->enabled)
+		pci_disable_device (pdev);
+#else
+	/* Note: assuming this is for Au1200 so au_... macros are used       */
+
+	/* Release power switch GPIO (Pb1200)                                */
+	au1000gpio_bit_term (USB_VBUS_GPIO, &init_usb_vbus_switch);
+
+	if (dev->enabled) {
+		au_writel ((au_readl (USB_MSR_BASE + USB_MSR_MCFG) &
+		            ~((u32) (1 << USBMSRMCFG_GMEMEN))),
+		           (USB_MSR_BASE + USB_MSR_MCFG));
+/* 		au_sync (); */
+		udelay (1000);
+	}
+#endif
+	pci_set_drvdata (pdev, 0);
+	the_controller = 0;
+
+	INFO ("unbind from pci %s\n", pdev->slot_name);
+
+	DBG ("kfree: OTG driver: %p\n", dev);
+	kfree (dev);
+}
+
+/**
+ * \brief
+ * OTG probe: init driver, assign resources
+ *
+ * \param  pdev  PCI device info
+ *
+ * \return  void
+ */
+static int otg_probe (struct pci_dev *pdev, const struct pci_device_id *id)
+{
+	struct otg *dev;
+	u32         resource, len;
+	void       *base = 0;
+	int         retval;
+	char        buf [8] = {0,0,0,0,0,0,0,0}, *bufp;
+
+	/* alloc, and start init */
+	dev = (struct otg *) kmalloc (sizeof(struct otg), SLAB_KERNEL);
+	if (!dev) {
+		ERR ("couldn't allocate memory for OTG driver\n");
+		retval = -ENOMEM;
+		goto done;
+	}
+	DBG ( "kmalloc: OTG driver: %p\n", dev);
+
+	/* hold global device pointer */
+	the_controller = dev;
+
+	memset (dev, 0, sizeof(struct otg));
+	spin_lock_init (&dev->lock);
+
+#ifndef CONFIG_USB_NON_PCI_OTGDEVICE
+
+	dev->pdev = pdev;
+
+	/* now all the pci goodies ...                                       */
+	if (pci_enable_device (pdev) < 0) {
+		ERR ("couldn't enable PCI device\n");
+		retval = -ENODEV;
+		goto done;
+	}
+	dev->enabled = 1;
+
+	/* BAR 0 holds all the registers                                     */
+
+	resource = pci_resource_start (pdev, 0);
+	len = pci_resource_len (pdev, 0);
+
+#else /* CONFIG_USB_NON_PCI_OTGDEVICE */
+
+	resource = USB_UOC_BASE;
+	len = USB_UOC_LEN;
+
+	/*
+	* Fill in the dummy pci_dev. Only those members actually
+	* dereferenced in this driver are initialized.
+	*/
+	memset(pdev, 0, sizeof(struct pci_dev));
+	strcpy(pdev->name, "non-PCI UOC");
+	strcpy(pdev->slot_name, "builtin");
+	pdev->resource[0].name = "UOC Registers";
+	pdev->resource[0].start = resource;
+	pdev->resource[0].end = resource + len - 1;
+	pdev->resource[0].flags = 0;
+	pdev->irq = AU1200_USB_INT;
+
+	dev->pdev = pdev;
+
+	/* enable UOC memory (Au1200)                                        */
+	/* Note: assuming this is for Au1200 so au_... macros are used       */
+	au_writel ((au_readl (USB_MSR_BASE + USB_MSR_MCFG) |
+	            (1 << USBMSRMCFG_GMEMEN)), (USB_MSR_BASE + USB_MSR_MCFG));
+	au_sync ();
+
+	/* Init power switch GPIO (Pb1200)                                   */
+
+	if (au1000gpio_bit_init (USB_VBUS_GPIO, &init_usb_vbus_switch)) {
+
+		ERR ("Couldn't initialize power switch GPIO\n");
+	}
+
+	dev->enabled = 1;
+
+#endif /* CONFIG_USB_NON_PCI_OTGDEVICE */
+
+	if (!request_mem_region (resource, len, driver_name)) {
+		ERR ("controller already in use\n");
+		retval = -EBUSY;
+		goto done;
+	}
+	dev->region = 1;
+
+	base = ioremap_nocache (resource, len);
+	if (!base) {
+		ERR ("couldn't map memory\n");
+		retval = -EFAULT;
+		goto done;
+	}
+
+	/* register base */
+	dev->regs = (struct otg_regs *) base;
+	bufp = buf;
+
+	dev->device = NULL;
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+/*** HS-A0 WA: BUG-3950: gadget disconnect notification                    ***/
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+	/* OTG state variables */
+	dev->otg_ctl = otg_ctl;
+
+	/* make sure all interrupts are disabled */
+	writel (OTG_INT_DISALL, &dev->regs->inten);
+	writel (OTG_INT_ENALL, &dev->regs->intr);
+
+	/* irq setup after old hardware is cleaned up */
+	if (!pdev->irq) {
+		ERR ("No IRQ. Check PCI setup!\n");
+		retval = -ENODEV;
+		goto done;
+	}
+#ifndef __sparc__
+
+	snprintf (buf, sizeof buf, "%d", pdev->irq);
+	bufp = buf;
+#else
+	bufp = __irq_itoa(pdev->irq);
+#endif
+	if (request_irq (pdev->irq, otg_isr, SA_SHIRQ, driver_name, dev) != 0)
+	{
+		ERR ("request interrupt %s failed\n", bufp);
+		retval = -EBUSY;
+		goto done;
+	}
+	dev->got_irq = 1;
+
+#endif /* CONFIG_USB_OTG || CONFIG_USB_OTGMUX_IDPIN || _HSA0_GADGET */
+
+	dev->chiprev = 0;
+
+#ifndef CONFIG_USB_NON_PCI_OTGDEVICE
+	pci_read_config_byte (pdev, PCI_REVISION_ID, (u8*) &dev->chiprev);
+#else
+        /* chip rev for Au1200 */
+        dev->chiprev = (u16) read_c0_prid() & 0xff;
+#endif
+
+	/* done */
+	pci_set_drvdata (pdev, dev);
+	INFO ("%s\n", driver_desc);
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+/*** HS-A0 WA: BUG-3950: gadget disconnect notification                    ***/
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+	INFO ("irq %s, pci mem %08x, chip rev %02x\n",
+	      bufp, resource, dev->chiprev);
+#else
+	INFO ("pci mem %08x, chip rev %02x\n",
+	      resource, dev->chiprev);
+#endif
+	bufp = DRIVER_VERSION;
+	INFO ("driver version: %s\n", bufp);
+
+	/* initialize the OTG controller */
+	otg_init_state (dev);
+
+#ifdef CONFIG_TEST_INTERFACE
+
+	/* registering to the test driver */
+	usb_otg_test_register_driver (&otg_test_driver);
+#endif
+
+#ifndef CONFIG_TEST_MODE_ONLY
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_GADGET)
+
+	/* registering to the device driver */
+	if (usb_gadget_register_otg (&otg_gadget_driver)) {
+		ERR ("gadget driver registration failed\n");
+		retval = -ENODEV;
+		goto done;
+	}
+#endif
+
+#ifdef CONFIG_USB_OTG
+
+	/* registering to the usbcore */
+	if (usb_bus_register_otg (&otg_host_driver)) {
+		usb_gadget_unregister_otg (&otg_gadget_driver);
+		ERR ("usbcore registration failed\n");
+		retval = -ENODEV;
+		goto done;
+	}
+#endif
+#endif
+
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+	/* finally activate OTG functionality */
+	otg_activate_state (dev);
+#endif
+	return 0;
+done:
+	if (dev) {
+
+/*** HS-A0 WA: BUG-3885: VB_SESS_VLD value too high                        ***/
+/*** HS-A0 WA: BUG-3943: gadget suspend issue                              ***/
+/*** HS-A0 WA: BUG-3950: gadget disconnect notification                    ***/
+#if defined(CONFIG_USB_OTG) || defined(CONFIG_USB_OTGMUX_IDPIN) || \
+    defined(CONFIG_USB_HSA0_GADGET)
+
+		if (dev->got_irq)
+			free_irq (pdev->irq, dev);
+#endif
+		if (dev->regs)
+			iounmap (dev->regs);
+
+		if (dev->region)
+			release_mem_region (pci_resource_start (pdev, 0),
+			                    pci_resource_len (pdev, 0));
+
+#ifndef CONFIG_USB_NON_PCI_OTGDEVICE
+
+		if (dev->enabled)
+			pci_disable_device (pdev);
+#else
+	/* Note: assuming this is for Au1200 so au_... macros are used       */
+		if (dev->enabled) {
+			au_writel ((au_readl (USB_MSR_BASE + USB_MSR_MCFG) &
+			            ~((u32) (1 << USBMSRMCFG_GMEMEN))),
+		               (USB_MSR_BASE + USB_MSR_MCFG));
+/* 			au_sync (); */
+			udelay (1000);
+		}
+#endif
+		pci_set_drvdata (pdev, 0);
+		the_controller = 0;
+
+		INFO ("unbind from pci %s\n", pdev->slot_name);
+
+		DBG ("kfree: OTG driver: %p\n", dev);
+		kfree (dev);
+	}
+	return retval;
+}
+
+
+/*****************************************************************************
+ *  More data
+ *****************************************************************************/
+
+/**
+ * \brief
+ * PCI ID table
+ *
+ */
+static struct pci_device_id pci_ids [] = { {
+	.vendor =	PCI_VENDOR_ID_AMD,
+	.device =	PCI_DEVICE_ID_AMD_CS5536_UOC,
+	.subvendor =	PCI_ANY_ID,
+	.subdevice =	PCI_ANY_ID,
+	.class = 	0,
+	.class_mask = 	0,
+
+}, { /* end: all zeroes */ }
+};
+
+#ifndef CONFIG_USB_NON_PCI_OTGDEVICE
+/**
+ * \brief
+ * PCI driver struct to be used for driver registration
+ * ( this is a "new style" PCI driver module )
+ *
+ */
+static struct pci_driver otg_pci_driver = {
+	.name =		(char *) driver_name,
+	.id_table =	pci_ids,
+	.probe =	otg_probe,
+	.remove =	otg_remove,
+
+	/* FIXME add power management support */
+};
+
+MODULE_DEVICE_TABLE (pci, pci_ids);
+#endif
+
+/* This comment closes the module definition from above. There can be multiple 
+   definitions of this kind in a file. See the doxygen documentation for more
+   information. */
+/** \}*/
+
+MODULE_DESCRIPTION (DRIVER_DESC);
+MODULE_AUTHOR ("Karsten Boge");
+MODULE_LICENSE ("GPL");
+
+static int __init init (void)
+{
+#ifdef CONFIG_USB_NON_PCI_OTGDEVICE
+
+	return (otg_probe (&pdev_dummy, pci_ids));
+#else
+        return (pci_module_init (&otg_pci_driver));
+#endif
+}
+module_init (init);
+
+static void __exit cleanup (void)
+{
+#ifdef CONFIG_USB_NON_PCI_OTGDEVICE
+
+	otg_remove (&pdev_dummy);
+#else
+	pci_unregister_driver (&otg_pci_driver);
+#endif
+}
+module_exit (cleanup);
